export const observed = Symbol();
export function observeProperties(classObject) {
    var _a, _b;
    const observedProperties = 'observedProperties' in classObject ? classObject.observedProperties : [];
    const Class = (_b = class extends classObject {
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            constructor(...args) {
                super(...args);
                this[_a] = {};
                for (const name of new Set(classObject.observedProperties)) {
                    const protoDescriptor = Object.getOwnPropertyDescriptor(classObject.prototype, name);
                    if (Object.hasOwnProperty.call(this, name)) {
                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                        ;
                        this[observed][name] = this[name];
                    }
                    Object.defineProperty(this, name, {
                        configurable: true,
                        get() {
                            if (protoDescriptor && protoDescriptor.get) {
                                this[observed][name] = protoDescriptor.get.call(this);
                            }
                            return this[observed][name];
                        },
                        set(newValue) {
                            const oldValue = this[name];
                            if (protoDescriptor && protoDescriptor.set) {
                                protoDescriptor.set.call(this, newValue);
                                if (protoDescriptor.get) {
                                    newValue = protoDescriptor.get.call(this);
                                }
                            }
                            this[observed][name] = newValue;
                            if (this.propertyChangedCallback && !Object.is(oldValue, newValue)) {
                                this.propertyChangedCallback(name, oldValue, newValue);
                            }
                        }
                    });
                }
            }
        },
        _a = observed,
        _b.observedProperties = observedProperties,
        _b);
    return Class;
}
//# sourceMappingURL=observe-properties.js.map