/**
 * Prop is a decorator which - when assigned to a property field on the class
 * - will add the field name to the `observedProperties` array.
 * `observeProperties()` can use the `observedProperties` array to add
 * observability hooks to all properties. In this way, adding `@prop` to a
 * field is the equivalent of making it observable.
 */
export declare function prop<K extends string>(proto: Record<K, unknown>, key: K): void;
//# sourceMappingURL=prop.d.ts.map